#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 2e4 + 5;
constexpr int VALMAX = 3e4;
typedef pair <int, int> PII;

int N;
PII V[NMAX];

int ans[NMAX];

class FenwickTree {
private:
    int aib[VALMAX+5];
    int ub(int x) {
        return (x&(-x));
    }
public:
    void Update (int pos, int val) {
        for (int i = pos; i <= VALMAX; i += ub(i))
            aib[i] = max(aib[i], val);
    }

    int Query (int pos) {
        int S = 0;

        for (int i = pos; i; i -= ub(i))
            S = max(S, aib[i]);

        return S;
    }
};

FenwickTree A;

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i ) {
        cin >> V[i].first >> V[i].second;
    }
    sort(V+1, V+N+1);

    for (int i = 1; i <= N; ++ i ) {
        ans[i] = A.Query(VALMAX - V[i].second) + 1;
        A.Update(VALMAX - V[i].second + 1, ans[i]);
    }

    int sol = 0;
    for (int i = 1; i <= N; ++ i ) {
        sol = max(sol, ans[i]);
    }

    cout << sol << '\n';
    return 0;
}
