#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<int, int>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

struct seggy {
	vector<int> tree;
	int n;

	seggy(int _size) {
		tree.resize(_size * 2, 0);
		n = _size;
	}

	void set(int idx, int val) {
		idx += n;
		if (tree[idx] > val)
			return;

		tree[idx] = val;
		idx /= 2;
		while (idx > 0)
			tree[idx] = max(tree[idx * 2], tree[idx * 2 + 1]), idx /= 2;
	}

	int query(int l, int r) {
		int out = (int)0;
		for (l += n, r += n; l < r; l /= 2, r /= 2) {
			if (l & 1)
				out = max(out, tree[l++]);
			if (r & 1)
				out = max(out, tree[--r]);
		}

		return out;
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	int maxEl = 0;
	vector<pii> rects(n);
	for (int i = 0; i < n; i++)
	{
		cin >> rects[i].first >> rects[i].second;
		maxEl = max(rects[i].second, maxEl);
	}
	sort(rects.begin(), rects.end());

	seggy seg(maxEl + 1);
	for (int i = 0; i < n; i++) {
		int maxi = seg.query(0, rects[i].second) + 1;
		seg.set(rects[i].second, maxi);
	}

	cout << seg.query(0, maxEl + 1) << endl;
}
