#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <cmath>

using ll = long long;

class SegmentTree{
private:
  std::vector<int> aint;
public:
  SegmentTree(int n) {
    aint.resize(1 + 4 * n);
  }
  void update(int node, int from, int to, int x, int val) {
    if(from < to) {
      int mid = (from + to) / 2;
      if(x <= mid)
        update(node * 2, from, mid, x, val);
      else
        update(node * 2 + 1, mid + 1, to, x, val);
      aint[node] = std::max(aint[node * 2], aint[node * 2 + 1]);
    } else
      aint[node] = std::max(aint[node], val);
  }

  int query(int node, int from, int to, int x, int y) {
    if(from == x && to == y)
      return aint[node];
    else {
      int mid = (from + to) / 2;
      if(x <= mid && y <= mid)
        return query(node * 2, from, mid, x, y);
      else if(mid + 1 <= x && mid + 1 <= y)
        return query(node * 2 + 1, mid + 1, to, x, y);
      else
        return std::max(query(node * 2, from, mid, x, mid),
                        query(node * 2 + 1, mid + 1, to, mid + 1, to));
    }
  }
};

int const nmax = 300005;

int main() {
  assert(1 == 0);

  int n;
  std::cin >> n;
  std::vector<std::pair<int,int>> v;
  for(int i = 1; i <= n; i++) {
    int x, y;
    std::cin >> x >> y;
    v.push_back({x, y});
  }
  std::sort(v.begin(), v.end());
  SegmentTree aint(1 + nmax);

  for(int i = 0;i < v.size(); i++) {
    int node = v[i].second;
    int sol = aint.query(1, 1, nmax, node + 1, nmax);
    aint.update(1, 1, nmax, node, sol + 1); 
  }
  std::cout << aint.query(1, 1, nmax, 1, nmax) << '\n';
  return 0;
}
