#include <bits/stdc++.h> 

using namespace std;

typedef long long int ll;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<pii> vp;


struct segtree {
	ll sizest;
	vll st;

	segtree(ll n) {
		for (sizest = 1; sizest < n; sizest = sizest * 2);
		st.resize(sizest * 2, 0);
	}

	void update(ll i, ll x) {
		i += sizest;
		st[i] += x;
		for (i /= 2; i; i /= 2) {
			st[i] = st[i * 2] + st[i * 2 + 1];
		}
	}

	ll query(ll l, ll r) {
		ll ans = 0;
		for (l += sizest, r += sizest; l <= r; l /= 2, r /= 2) {
			if (l % 2) {
				ans += st[l++];
			}
			if (r % 2 == 0) {
				ans += st[r--];
			}
		}
		return ans;
	}

};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vp rec(n);

	int a, b;
	for (int i = 0; i < n; i++) {
		cin >> a >> b;
		rec[i] = { a,b };
	}

	int maxs = 30000;
	sort(rec.begin(), rec.end());
	unique(rec.begin(), rec.end());
	while (rec[rec.size() -1].first ==rec[rec.size() -2].first && rec[rec.size()-1].second == rec[rec.size() - 2].second)
	{
		rec.pop_back();
	}
	segtree st(maxs);

	for (int i = 0; i < rec.size(); i++) {
		st.update(rec[i].second, 1);
	}

	ll index = 0;
	ll curr;
	ll ans = 0;
	bool flag = true;
	for (int i = 0; i < rec.size()-1; i++) {
		if (i >= index) {
			flag = true;
		}
		if (rec[index].first == rec[index + 1].first) flag = true;
		if (flag) {
			while (rec[index].first == rec[index + 1].first)
			{
				st.update(rec[index].second, -1);
				index++;
			}
			st.update(rec[index].second, -1);
			index++;
			flag = false;
		}
		curr = st.query(0, rec[i].second - 1);
		ans = max(ans, curr);
	}
	cout << ans + 1;

	return 0;
}

