#include <iostream>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 2e4 + 1;

int N;
PII A[NMAX];

int dp[NMAX];

class FenwickTree
{
    static const int NMAX = 3e4 + 1;

    int a[NMAX];

private:
    inline int LSB (int X)
    {
        return (X & (-X));
    }

    inline int my_max (int a, int b)
    {
        return ((a > b) ? a : b);
    }

public:
    inline void Update (int pos, int Val)
    {
        for(int i = pos; i <= 30000; i += LSB(i))
            a[i] = my_max(a[i], Val);

        return;
    }

    inline int Query (int pos)
    {
        int ans = 0;

        for(int i = pos; i >= 1; i -= LSB(i))
            ans = my_max(ans, a[i]);

        return ans;
    }
} AIB;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].first >> A[i].second;

    return;
}

auto cmp = [] (PII A, PII B)
{
    if(A.first > B.first)
        return 1;

    if(A.first < B.first)
        return 0;

    if(A.second > B.second)
        return 1;

    return 0;
};

static inline void Solve ()
{
    sort(A + 1, A + N + 1, cmp);

    int ans = 0;

    for(int i = 1; i <= N; ++i)
    {
        dp[i] = 1 + AIB.Query(A[i].second - 1);

        AIB.Update(A[i].second, dp[i]);

        if(dp[i] > ans)
            ans = dp[i];
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
