#include <bits/stdc++.h>

using namespace std;
template <typename T>
class Segtree {
    vector <T> t; T neutral;
    int n;
    function <T(T, T)> f;
public:
    template <typename Iterator> Segtree(Iterator l, Iterator r, T neut, function <T(T, T)> _f) : neutral(neut), f(_f) {
        n = distance(l, r); int h = 31 - __builtin_clz(n);
        t.resize(1 << h + 2, neutral);
        for(int i = n; l != r; i++, l++) t[i] = *l;
        for(int i = n - 1; i > 0; i--) t[i] = f(t[i << 1], t[i << 1 | 1]);
    }
    void update(int pos, int x) {
        for(t[pos += n] = x; pos > 1; pos >>= 1)
            t[pos >> 1] = f(t[pos], t[pos ^ 1]);
    }
    T query(int l, int r) {
        T res(neutral);
        for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if(l & 1) res = f(res, t[l++]);
            if(r & 1) res = f(res, t[--r]);
        }
        return res;
    }
};
struct pos {
    int x, y;
    bool operator <(const pos& other) {return x == other.x ? y > other.y : x < other.x; }
};
const int NMAX = 3e4;
pos v[NMAX + 5];

int main()
{
    int n;
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> v[i].x >> v[i].y;
    sort(v + 1, v + n + 1);
    //for(int i = 1; i <= n; i++) cout << v[i].x << v[i].y << " \n"[i == n];
    vector <int> d(NMAX + 5, 0);
    Segtree <int> S(d.begin(), d.begin() + NMAX + 1, 0, [](int a, int b){return max(a, b);});
    //cout << ".";
    int res = 0;
    for(int i = 1; i <= n; i++) {
        //cout << i;
        int q = S.query(v[i].y + 1, NMAX + 1);
        S.update(v[i].y, q + 1);
        res = max(res, q + 1);
    }
    cout << res;
    return 0;
}
