#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <queue>

using namespace std;

typedef long long ll;

vector <vector <ll> > adjl(20000);

int main(){
    
    ll n;
    cin >> n;
    
    vector <pair <ll,ll> > rec(n);
    for (int i = 0; i < n; i++)
        cin >> rec[i].first >> rec[i].second;
    
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n;j++)
            if (!(rec[i].first >= rec[j].first && rec[i].second >= rec[j].second) && !(rec[i].first <= rec[j].first && rec[i].second <= rec[j].second))
                adjl[i].push_back(j), adjl[j].push_back(i);
    
    ll l = 0, r = n+1;
    
    vector <ll> temp(n);
    vector <ll> vis(n, false);
    queue <ll> bfs;
    
    while (l < r){
        
        ll mid = (l+r+1)/2;
        
        for (int i = 0; i < n; i++)
            vis[i] = false, temp[i] = adjl[i].size();
        
        for (int i = 0; i < n; i++)
            if (temp[i] < mid)
                bfs.push(i), vis[i] = true;
        
        while (bfs.size()){
            
            ll f = bfs.front();
            bfs.pop();
            
            for (int i = 0; i < adjl[f].size(); i++){
                
                ll v = adjl[f][i];
                temp[v]--;
                if (temp[v] < mid && !vis[v])
                    vis[v] = true, bfs.push(v);

                
            }
            
        }
        
        bool svi = true;
        for (int i = 0; i < n; i++)
            if (!vis[i])
                svi = false;
        
        if (!svi)
            l = mid;
        else
            r = mid - 1;
        
    }
    
    cout << l + 1;
    
    /*
     7
     1 3
     4 3
     5 1
     5 1
     3 4
     9 4
     1 1
     */
    
    
}
