#include <bits/stdc++.h>

using namespace std;

#define int long long


class SegmentTree {
public:
	vector<int> a;
	int n;

	SegmentTree(int n): n(n) {
		a.resize(4 * n);
	}

	int size() const {
		return n;
	}

	int get(int l, int r) {
		l += n;
		r += n;
		int ans = 0;
		while(l < r) {
			ans = max(ans, a[l]);
			ans = max(ans, a[r - 1]);
			l = (l + 1) / 2;
			r = r / 2;
		}
		return ans;
	}
	int get(int x) {
		return a[n + x];
	}

	void update(int x, int val) {
		x += n;
		while(x >= 1) {
			a[x] = max(a[x], val);
			x /= 2;
		}
	}
};


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	vector<pair<int, int>> rects(n);
	for(int i = 0; i < n; i++) {
		cin >> rects[i].first >> rects[i].second;
	}
	sort(rects.begin(), rects.end());

	vector<int> nums;
	for(int i = 0; i < rects.size(); i++) {
		if(i == 0 || rects[i - 1].first != rects[i].first) {
			nums.push_back(rects[i].second);
		} else {
			nums.back() = rects[i].second;
		}
	}


	SegmentTree st(30001);
	for(int x: nums) {
		st.update(x, 1 + st.get(x + 1, st.size()));
	}

	cout << st.get(0, st.size()) << endl;

	return 0;
}
