#include <bits/stdc++.h>

using namespace std;

#define int long long


class SegmentTree {
public:
	vector<int> a;
	int n;

	SegmentTree(int n): n(n) {
		a.resize(4 * n);
	}

	int size() const {
		return n;
	}

	int get(int l, int r) {
		l += n;
		r += n;
		int ans = 0;
		while(l < r) {
			ans = max(ans, a[l]);
			ans = max(ans, a[r - 1]);
			l = (l + 1) / 2;
			r = r / 2;
		}
		return ans;
	}
	int get(int x) {
		return a[n + x];
	}

	void update(int x, int val) {
		x += n;
		while(x >= 1) {
			a[x] = max(a[x], val);
			x /= 2;
		}
	}
};


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	map<int, vector<int>> rects;
	for(int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		rects[x].push_back(y);
	}


	SegmentTree st(30001);
	for(auto& [x, yy]: rects) {
		vector<pair<int, int>> updates;
		for(int y: yy) {
			updates.emplace_back(y, 1 + st.get(y + 1, st.size()));
		}
		for(auto [y, val]: updates) {
			st.update(y, val);
		}
	}

	cout << st.get(0, st.size()) << endl;

	return 0;
}
