#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


const ll inf = 1e18;


struct rect {
    ll x, y;
};


bool operator<(const rect& r1, const rect& r2) {
    if (r1.x != r2.x) {
        return r1.x < r2.x;
    }
    return r1.y < r2.y;
}


int n;
vector<rect> r;
vector<ll> a;


int bin_find(vector<ll> &a, int x) {
    int l = 0;
    int r = a.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (a[m] > x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


int32_t main() {
    cin >> n;
    r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> r[i].x >> r[i].y;
    }
    sort(all(r));
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i] = r[i].y;
    }
    vector<ll> dp;
    dp.reserve(n + 1);
    dp.push_back(inf);
    for (int i = 0; i < n; ++i) {
        int x = bin_find(dp, a[i]);
        if (x + 1 == dp.size()) {
            dp.push_back(0);
        }
        dp[x + 1] = a[i];
    }
    cout << (int)(dp.size()) - 1 << "\n";
    return 0;
}