#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

const int INF = 1e9;

struct Rectangle {
    int x, y;

    Rectangle() {
        x = y = 0;
    }

    Rectangle(int _x, int _y) {
        x = _x;
        y = _y;
    }

    bool operator<(const Rectangle& comp) {
        if (x == comp.x) {
            return y < comp.y;
        }

        return x < comp.x;
    }
};

int find_lis(vector<int>& nums) {
    vector<int> dp;

    for (int num : nums) {
        if (dp.empty() or num > dp.back()) {
            dp.push_back(num);
            continue;
        }
        
        if (num == dp.back()) {
            continue;
        }

        int target = upper_bound(dp.begin(), dp.end(), num) - dp.begin();
        dp[target] = num;
    }

    return (int) dp.size();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<Rectangle> rectangles(n);
    for (int i = 0; i < n; ++i) {
        cin >> rectangles[i].x >> rectangles[i].y;
    }

    sort(rectangles.begin(), rectangles.end());
    
    int res = 1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int counter = 0, last_y = 1e9, last_x = -1;
        bool is_valid = true;

        for (int i = 0; i < n; ++i) {
            if ((mask & (1 << i)) == 0) {
                continue;
            }

            if (rectangles[i].x == last_x) {
                is_valid = false;
                break;
            }

            last_x = rectangles[i].x;

            if (rectangles[i].y >= last_y) {
                is_valid = false;
                break;
            }

            last_y = rectangles[i].y;
            ++counter;
        }

        if (is_valid) {
            res = max(res, counter);
        }
    }

    cout << res << endl;
return 0;
}