#include <iostream>
#include <vector>
#include <algorithm>

#define endl '\n'

using namespace std;

const int INF = 1e9;

struct Rectangle {
    int x, y;

    Rectangle() {
        x = y = 0;
    }

    Rectangle(int _x, int _y) {
        x = _x;
        y = _y;
    }

    bool operator<(const Rectangle& comp) {
        if (x == comp.x) {
            return y < comp.y;
        }

        return x < comp.x;
    }
};

int find_lis(vector<int>& nums) {
    vector<int> dp;

    for (int num : nums) {
        if (dp.empty() or num > dp.back()) {
            dp.push_back(num);
            continue;
        }
        
        if (num == dp.back()) {
            continue;
        }

        int target = upper_bound(dp.begin(), dp.end(), num) - dp.begin();
        dp[target] = num;
    }

    return (int) dp.size();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<Rectangle> rectangles(n);
    for (int i = 0; i < n; ++i) {
        cin >> rectangles[i].x >> rectangles[i].y;
    }

    sort(rectangles.begin(), rectangles.end());
    
    int res = 1;
    vector<int> curr;
    for (int mask = 0; mask < (1 << n); ++mask) {
        curr.clear();

        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                curr.push_back(i);
            }
        }

        int m = (int) curr.size();
        bool is_valid = true;

        for (int i = 0; i < m; ++i) {
            for (int j = i + 1; j < m; ++j) {
                if (rectangles[curr[i]].x <= rectangles[curr[j]].x
                and rectangles[curr[i]].y <= rectangles[curr[j]].y) {
                    is_valid = false;
                    break;
                }
            }
        }

        if (is_valid) {
            res = max(res, m);
        }
    }

    cout << res << endl;
return 0;
}